#include "windows.h"
#include "banner.h"

void InitDemo (HINSTANCE, HINSTANCE, int);
void InitDemoFirst (HINSTANCE);
void InitDemoEvery (HINSTANCE, int);
long FAR PASCAL DemoWindowProc (HWND, unsigned, WORD, LONG);

LPSTR lpAppName = "Demo";
HINSTANCE hInst;

static WPARAM MessagePump(DWORD Delay)
    {
    MSG     msg;
    DWORD   StartTime   = GetTickCount();

    while(GetMessage(&msg, NULL, 0, 0))
        {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
        if(msg.time - StartTime > Delay)
            return 0;
        }
    return msg.wParam;
    }

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hInstance,
                 HINSTANCE hPrevInstance, LPSTR lpszCmdLine,
                                                int cmdShow)
{
    InitDemo(hInstance, hPrevInstance, cmdShow);
    return MessagePump((DWORD)-1);
}

void InitDemo(HINSTANCE  hInstance, HINSTANCE  hPrevInstance, int cmdShow)
{
    if (!hPrevInstance) InitDemoFirst (hInstance);
    InitDemoEvery(hInstance, cmdShow);
}

void InitDemoFirst (HINSTANCE  hInstance)
{
    WNDCLASS    wcDemoClass;
    wcDemoClass.lpszClassName   = lpAppName;
    wcDemoClass.hInstance       = hInstance;
    wcDemoClass.lpfnWndProc     = (WNDPROC)DemoWindowProc;
    wcDemoClass.hCursor         = LoadCursor (NULL, IDC_ARROW);
    wcDemoClass.hIcon           = LoadIcon (hInstance, lpAppName);
    wcDemoClass.lpszMenuName    = lpAppName;
    wcDemoClass.hbrBackground   = GetStockObject (WHITE_BRUSH);
    wcDemoClass.style           = CS_HREDRAW | CS_VREDRAW;
    wcDemoClass.cbClsExtra      = 0;
    wcDemoClass.cbWndExtra      = 0;
    RegisterClass (&wcDemoClass);
}

void InitDemoEvery (HINSTANCE  hInstance, int cmdShow)
{
    HWND  hWnd;
    hInst = hInstance;
    hWnd = CreateWindow (lpAppName, lpAppName, WS_OVERLAPPEDWINDOW,
            CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance,
            NULL);
    ShowWindow (hWnd, cmdShow);
    UpdateWindow (hWnd);
}

static void Delay(WORD wMs)
{
	LONG lTicks = 0, lDelay;
	lDelay = GetTickCount() + wMs;
	while (lTicks < lDelay) lTicks = GetTickCount();
}

long FAR PASCAL _export DemoWindowProc (HWND hWnd, UINT msg,
                WORD wParam, LONG lParam)
{
    static BOOL bFirstTime = TRUE;
    switch (msg)
    {
    case WM_CREATE:            // show opening banner
        OpenBanner(hWnd,
            LoadIcon(hInst,lpAppName),
            lpAppName,
            "DEMO VERSION\nfor\nWindows/DOS Developers Journal.",
            "Copyright  1994 Your Name\nAll rights reserved.");
        Delay(1000);
            break;

      case WM_DESTROY:                       
          PostQuitMessage(0);
          break;
   
    case WM_PAINT:
        if(bFirstTime)        // simulate additional loading
        {                   // when done, close banner
            Delay(2500);
            CloseBanner();
            bFirstTime = !bFirstTime;
        }
        return(DefWindowProc(hWnd, msg, wParam, lParam));
   
    case WM_COMMAND:
        switch(wParam)
        {
                            //(respond to command messages)
        }
        break;
   
    default:
         return(DefWindowProc(hWnd, msg, wParam, lParam));
    }
    return 0;
}
